#ifndef __MENU_H__
#define __MENU_H__
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MOUSE_BUTTON_1_PRESSED   0x01
#define MOUSE_BUTTON_2_PRESSED   0x02
#define MOUSE_BUTTON_1_RELEASED  0x04
#define MOUSE_BUTTON_2_RELEASED  0x08

typedef void (* MenuCallback)(int Data);

void MenuItem(char *Name, MenuCallback Callback, int ClientData);
void ToggleMenuItem(char *Name, MenuCallback Callback, int InitialState);
void SubMenu(char *Name);
void EndSubMenu(void);
void EndMenu(void);
void MenuAction(int MouseButton, int MouseX, int MouseY);
void SetVirtualPage(char *P);
void SetScreenSize(int Width, int Height);
void SetMenuColors(int Light, int Medium, int Dark);
int  IsInMenu(void);

#endif
