#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>
#include "types.h"
#include "inertia.h"
#include <glide.h>

ViewObject   View;   /* The View System */
VectorObject Obj;   /* A vector object */
int          i;

main()
{
  if (G_InitInertia() != I_OK)
    {
      G_Shutdown();
      printf("Error! Inertia/Glide could not be initialized\n");
      exit(0);
    }

  if (LoadPalette("COPPRENV.PAL", 0) != I_OK)       /* load the palette */
    {
      printf("Error loading Palette.\n");
      exit(0);
    }
  if (LoadGVO(&Obj, "TORUS.GVO", 0) != I_OK)         /* load the vector object */
    {
      printf("Error loading TORUS object.\n");
      exit(0);
    }

  InitView(&View); /* init the view */

  if (G_OpenWindow() != I_OK)
    {
      G_Shutdown();
      printf("Error! Inertia/Glide could not be initialized\n");
      exit(0);
    }

  G_SetPalette(); /* Set the palette */

  SetViewPort(&View, 0, 0, 639, 479, 1);

  SetAbsoluteLocation(&Obj, 0, 0, 0); /* Set the object's location */
  PushLightSource(0, 0, -1);  /* Add a light source */

  SetRenderMask(&Obj, SMOOTH | GOURAUD);    /* set smooth surface */

  SetBaseColor(&Obj, 36);   /* set the polygon colors */

  i = 0;

  do
    {
      SetDeltaRotation(&Obj, 0.01, 0, 0.01);
      SetViewLocation(&View, cos(i*2*PI/1024) * Obj.Radius * 2, 0, sin(i*2*PI/1024) * Obj.Radius * 2);
      SetFocusPoint(&View, 0, 0, 0, 0);
      AddToRenderList(&View, &Obj);      /* add it to the view */
      Render(NULL, 0, 0);                  /* render to the virtual page */
      G_Flip();                           /* Copy the page over */

      i = (i + 1) & 1023;
    }
  while (!kbhit());

  FreeView(&View);         /* Free the view's allocated memory */
  FreeVectorObject(&Obj);  /* free the vector object's allocated memory */

  FreeTexture(0);         /* Free the phong map */

  G_Shutdown();
}
